extends Weapon

const DAMAGE = 1.0

@onready var animation_player: AnimationPlayer = $AnimationPlayer

@onready var aimcast: RayCast3D = get_tree().get_first_node_in_group("AimCastGroup")
@onready var impact_scene: PackedScene = load("res://src/effects/ballistic_impact.tscn")


func fire() -> void:
	if aimcast.is_colliding():
		var target: Node3D = aimcast.get_collider()
		if target is DamageableBody:
			(target as DamageableBody).deal_damage(DAMAGE)
		else:
			var impact: GPUParticles3D = impact_scene.instantiate()
			var point: Vector3 = aimcast.get_collision_point()
			var normal: Vector3 = aimcast.get_collision_normal()
			target.add_child(impact)
			impact.reparent(target)
			impact.look_at_from_position(point, normal + point, Vector3(-normal.y, normal.x, 0.0))


func trigger() -> void:
	animation_player.play("fire")
